class KApplication

# class KApplication | Controls and provides information to all KDE applications. More...
Definition | `#include <kapplication.h>`
Inherits | KInstance [public ], QApplication (qt) [public ]
Inherited by | KUniqueApplication
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum CaptionLayout { CaptionAppLast=1, CaptionAppFirst, CaptionNoApp }
- enum ShutdownConfirm { ShutdownConfirmDefault = -1, /** }
- enum ShutdownType { ShutdownTypeDefault = -1, /** }
- enum ShutdownMode { ShutdownModeDefault = -1, /** }
- enum { ShiftModifier = 1<<0, LockModifier = 1<<1, ControlModifier = 1<<2, Modifier1 = 1<<3, Modifier2 = 1<<4, Modifier3 = 1<<5, Modifier4 = 1<<6, Modifier5 = 1<<7 }
- enum { Button1Pressed = 1<<8, Button2Pressed = 1<<9, Button3Pressed = 1<<10, Button4Pressed = 1<<11, Button5Pressed = 1<<12 }
- enum SettingsCategory { SETTINGS_MOUSE, SETTINGS_COMPLETION, SETTINGS_PATHS, SETTINGS_POPUPMENU, SETTINGS_QT, SETTINGS_SHORTCUTS }

#### Public Methods

- KApplication ( bool allowStyles=true, bool GUIenabled=true)
- KApplication (Display *display, int& argc, char** argv, const QCString& rAppName, bool allowStyles=true, bool GUIenabled=true)
- KApplication (int& argc, char** argv, const QCString& rAppName, bool allowStyles=true, bool GUIenabled=true)
- virtual ~KApplication ()
- KConfig* sessionConfig ()
- bool isRestored () const
- void disableSessionManagement ()
- bool requestShutDown ( ShutdownConfirm confirm = ShutdownConfirmDefault, ShutdownType sdtype = ShutdownTypeDefault, ShutdownMode sdmode = ShutdownModeDefault )
- void propagateSessionManager ()
- void commitData ( QSessionManager& sm )
- void saveState ( QSessionManager& sm )
- bool sessionSaving () const
- QPixmap icon () const
- QString iconName () const
- QPixmap miniIcon () const
- QString miniIconName () const
- void setTopWidget ( QWidget *topWidget )
- void invokeHelp ( const QString& anchor = QString::null, const QString& appname = QString::null ) const
- void invokeHTMLHelp ( const QString& aFilename, const QString& aTopic = QString::null ) const
- void invokeMailer ( const QString &address, const QString &subject )
- void invokeMailer ( const KURL &mailtoURL )
- void invokeMailer (const QString &to, const QString &cc, const QString &bcc, const QString &subject, const QString &body, const QString &messageFile = QString::null, const QStringList &attachURLs = QStringList())
- QString caption () const
- KStyle* kstyle () const
- QString makeStdCaption ( const QString &userCaption, bool withAppName=true, bool modified=false ) const
- QString tempSaveName ( const QString& pFilename ) const
- QString checkRecoverFile ( const QString& pFilename, bool& bRecover ) const
- Display * getDisplay ()
- void enableStyles ()
- void disableStyles ()
- void installX11EventFilter ( QWidget* filter )
- void addKipcEventMask (int id)
- void removeKipcEventMask (int id)
- QCString startupId () const
- void setStartupId ( const QCString& startup_id )
- QString geometryArgument () const
- void installKDEPropertyMap ()
- bool authorize (const QString &genericAction)
- bool authorizeKAction (const char *action)
- bool authorizeURLAction (const QString &action, const KURL &baseURL, const KURL &destURL)
- bool notify (QObject *receiver, QEvent *event)
- int xioErrhandler ()
- void iceIOErrorHandler ( _IceConn *conn )

#### Public Slots

- void invokeBrowser ( const QString &url )
- void ref ()
- void deref ()

#### Signals

- void kdisplayPaletteChanged ()
- void kdisplayStyleChanged ()
- void kdisplayFontChanged ()
- void appearanceChanged ()
- void toolbarAppearanceChanged (int)
- void backgroundChanged (int desk)
- void settingsChanged (int category)
- void iconChanged (int group)
- void kipcMessage (int id, int data)
- void saveYourself ()
- void shutDown ()

#### Public Static Methods

- static void addCmdLineOptions ()
- static KApplication* kApplication ()
- static DCOPClient * dcopClient ()
- static void disableAutoDcopRegistration ()
- static QCString launcher ()
- static int startServiceByName ( const QString& _name, const QString &URL, QString *error=0, QCString *dcopService=0, int *pid=0, const QCString &startup_id = "", bool noWait = false )
- static int startServiceByName ( const QString& _name, const QStringList &URLs=QStringList(), QString *error=0, QCString *dcopService=0, int *pid=0, const QCString &startup_id = "", bool noWait = false )
- static int startServiceByDesktopPath ( const QString& _name, const QString &URL, QString *error=0, QCString *dcopService=0, int *pid = 0, const QCString &startup_id = "", bool noWait = false )
- static int startServiceByDesktopPath ( const QString& _name, const QStringList &URLs=QStringList(), QString *error=0, QCString *dcopService=0, int *pid = 0, const QCString &startup_id = "", bool noWait = false )
- static int startServiceByDesktopName ( const QString& _name, const QString &URL, QString *error=0, QCString *dcopService=0, int *pid = 0, const QCString &startup_id = "", bool noWait = false )
- static int startServiceByDesktopName ( const QString& _name, const QStringList &URLs=QStringList(), QString *error=0, QCString *dcopService=0, int *pid = 0, const QCString &startup_id = "", bool noWait = false )
- static int kdeinitExec ( const QString& name, const QStringList &args=QStringList(), QString *error=0, int *pid = 0 )
- static int kdeinitExecWait ( const QString& name, const QStringList &args=QStringList(), QString *error=0, int *pid = 0 )
- static int random ()
- static QString randomString (int length)
- static uint keyboardModifiers ()
- static uint mouseState ()
- static void startKdeinit ()
- static QPalette createApplicationPalette ()
- static QPalette createApplicationPalette ( KConfig *config, int contrast )

#### Public Members

- static bool loadedByKdeinit

#### Protected Methods

- KApplication ( bool allowStyles, bool GUIenabled, KInstance* _instance )
- bool x11EventFilter ( XEvent * )
- virtual void virtual_hook ( int id, void* data )

#### Protected Members

- Display *display
- Atom kipcCommAtom
- int kipcEventMask
- static KApplication *KApp
- int pArgc

## Detailed Description

Controls and provides information to all KDE applications.

Only one object of this class can be instantiated in a single app. This instance is always accessible via the kApplication() method.

This class provides the following services to all KDE applications.

- It controls the event queue (see QApplication ).
- It provides the application with KDE resources such as accelerators, common menu entries, a KConfig object. session management events, help invocation etc.
- Installs a signal handler for the SIGCHLD signal in order to avoid zombie children. If you want to catch this signal yourself or don't want it to be caught at all, you have set a new signal handler (or SIG_IGN) after KApplication's constructor has run.
- It can start new services

The way a service gets started depends on the 'X-DCOP-ServiceType' entry in the desktop file of the service:

There are three possibilities:

- X-DCOP-ServiceType=None (default) Always start a new service, don't wait till the service registers with dcop.
- X-DCOP-ServiceType=Multi Always start a new service, wait until the service has registered with dcop.
- X-DCOP-ServiceType=Unique Only start the service if it isn't already running, wait until the service has registered with dcop.

enum CaptionLayout { CaptionAppLast=1, CaptionAppFirst, CaptionNoApp } | ### CaptionLayout

KApplication ( bool allowStyles=true, bool GUIenabled=true) | ### KApplication

This constructor takes aboutData and command line arguments from KCmdLineArgs.

Parameters:

allowStyles | Set to false to disable the loading on plugin based styles. This is only useful to applications that do not display a GUI normally. If you do create an application with `allowStyles` set to false it normally runs in the background but under special circumstances displays widgets. Call enableStyles() before displaying any widgets.
GUIenabled | Set to false to disable all GUI stuff. This implies no styles either.

KApplication (Display *display, int& argc, char** argv, const QCString& rAppName, bool allowStyles=true, bool GUIenabled=true) | ### KApplication

Constructor. Parses command-line arguments. Use this constructor to use KApplication in a Motif or Xt program.

Parameters:

display | Will be passed to Qt as the X display. The display must be valid and already opened.
rAppName | application name. Will be used for finding the associated message files and icon files, and as the default registration name for DCOP. This is a mandatory parameter.
allowStyles | Set to false to disable the loading on plugin based styles. This is only useful to applications that do not display a GUI normally. If you do create an application with `allowStyles` set to false that normally runs in the background but under special circumstances displays widgets call enableStyles() before displaying any widgets.
GUIenabled | Set to false to disable all GUI stuff. This implies no styles either.

KApplication (int& argc, char** argv, const QCString& rAppName, bool allowStyles=true, bool GUIenabled=true) | ### KApplication

// REMOVE FOR KDE 4.0 - using it only gives crashing applications because // KCmdLineArgs::init isn't called

Constructor. Parses command-line arguments.

Parameters:

rAppName | application name. Will be used for finding the associated message files and icon files, and as the default registration name for DCOP. This is a mandatory parameter.
allowStyles | Set to false to disable the loading on plugin based styles. This is only useful to applications that do not display a GUI normally. If you do create an application with `allowStyles` set to false that normally runs in the background but under special circumstances displays widgets call enableStyles() before displaying any widgets.
GUIenabled | Set to false to disable all GUI stuff. This implies no styles either.

void addCmdLineOptions () | ### addCmdLineOptions

[static]

Add Qt and KDE command line options to KCmdLineArgs.

~KApplication () | ### ~KApplication

[virtual]

KApplication* kApplication () | ### kApplication

[static]

Returns the current application object.

This is similar to the global QApplication pointer qApp. It allows access to the single global KApplication object, since more than one cannot be created in the same application. It saves you the trouble of having to pass the pointer explicitly to every function that may require it.

Returns: the current application object

KConfig* sessionConfig () | ### sessionConfig

Returns the application session config object.

Returns: A pointer to the application's instance specific KConfig object.

See also: KConfig

bool isRestored () | ### isRestored

[const]

Is the application restored from the session manager?

Returns: If true, this application was restored by the session manager. Note that this may mean the config object returned by sessionConfig() contains data saved by a session closedown.

See also: sessionConfig()

void disableSessionManagement () | ### disableSessionManagement

Disables session management for this application.

Useful in case your application is started by the initial "startkde" script.

enum ShutdownConfirm { ShutdownConfirmDefault = -1, /** } | ### ShutdownConfirm

Obey the user's confirmation setting.

enum ShutdownType { ShutdownTypeDefault = -1, /** } | ### ShutdownType

Select previous action or the default if it's the first time.

enum ShutdownMode { ShutdownModeDefault = -1, /** } | ### ShutdownMode

Select previous mode or the default if it's the first time.

bool requestShutDown ( ShutdownConfirm confirm = ShutdownConfirmDefault, ShutdownType sdtype = ShutdownTypeDefault, ShutdownMode sdmode = ShutdownModeDefault ) | ### requestShutDown

Asks the session manager to shut the session down.

Using `confirm` == ShutdownConfirmYes or `sdtype` != ShutdownTypeDefault or `sdmode` != ShutdownModeDefault causes the use of ksmserver's DCOP interface. The remaining two combinations use the standard XSMP and will work with any session manager compliant with it.

Parameters:

confirm | Whether to ask the user if he really wants to log out. ShutdownConfirm
sdtype | The action to take after logging out. ShutdownType
sdmode | If/When the action should be taken. ShutdownMode

Returns: true on sucess, false if the session manager could not be contacted.

void propagateSessionManager () | ### propagateSessionManager

Propagates the network address of the session manager in the SESSION_MANAGER environment variable so that child processes can pick it up.

If SESSION_MANAGER isn't defined yet, the address is searched in $HOME/.KSMserver.

This function is called by clients that are started outside the session ( i.e. before ksmserver is started), but want to launch other processes that should participate in the session. Examples are kdesktop or kicker.

void commitData ( QSessionManager& sm ) | ### commitData

Reimplemented from QApplication.

void saveState ( QSessionManager& sm ) | ### saveState

Reimplemented from QApplication.

bool sessionSaving () | ### sessionSaving

[const]

Returns true if the application is currently saving its session data (most probably before KDE logout). This is intended for use mainly in KMainWindow::queryClose() and KMainWindow::queryExit().

See also: KMainWindow::queryClose, KMainWindow::queryExit

DCOPClient * dcopClient () | ### dcopClient

[static]

Returns a pointer to a DCOPClient for the application. If a client does not exist yet, it is created when this function is called.

Returns: the DCOPClient for the application

void disableAutoDcopRegistration () | ### disableAutoDcopRegistration

[static]

Disable automatic dcop registration Must be called before creating a KApplication instance to have an effect.

QPixmap icon () | ### icon

[const]

Returns a QPixmap with the application icon.

Returns: the application icon

QString iconName () | ### iconName

[const]

Returns the name of the application icon.

Returns: the icon's name

QPixmap miniIcon () | ### miniIcon

[const]

Returns the mini-icon for the application as a QPixmap.

Returns: the application's mini icon

QString miniIconName () | ### miniIconName

[const]

Returns the name of the mini-icon for the application.

Returns: the mini icon's name

void setTopWidget ( QWidget *topWidget ) | ### setTopWidget

Sets the top widget of the application. This means basically applying the right window caption and icon. An application may have several top widgets. You don't need to call this function manually when using KMainWindow.

Parameters:

topWidget | A top widget of the application.

See also: icon(), caption()

void invokeHelp ( const QString& anchor = QString::null, const QString& appname = QString::null ) | ### invokeHelp

[const]

Invokes the KHelpCenter HTML help viewer from docbook sources.

Parameters:

anchor | This has to be a defined anchor in your docbook sources. If empty the main index is loaded
appname | This allows you to show the help of another application. If empty the current name() is used

void invokeHTMLHelp ( const QString& aFilename, const QString& aTopic = QString::null ) | ### invokeHTMLHelp

[const]

Invoke the khelpcenter HTML help viewer from HTML sources. Please use invokeHelp() instead.

Parameters:

aFilename | The filename that is to be loaded. Its location is computed automatically according to the KFSSTND. If `aFilename` is empty, the logical appname with .html appended to it is used.
aTopic | This allows context-sensitive help. Its value will be appended to the filename, prefixed with a "#" (hash) character.

void invokeMailer ( const QString &address, const QString &subject ) | ### invokeMailer

Convenience method; invokes the standard email application.

Parameters:

address | The destination address
subject | Subject string. Can be QString::null.

void invokeMailer ( const KURL &mailtoURL ) | ### invokeMailer

Invokes the standard email application.

Parameters:

mailtoURL | A mailto URL.

void invokeMailer (const QString &to, const QString &cc, const QString &bcc, const QString &subject, const QString &body, const QString &messageFile = QString::null, const QStringList &attachURLs = QStringList()) | ### invokeMailer

Convenience method; invokes the standard email application.

All parameters are optional.

Parameters:

to | The destination address.
cc | The Cc field
bcc | The Bcc field
subject | Subject string
body | A string containing the body of the mail (exclusive with messageFile)
messageFile | A file (URL) containing the body of the mail (exclusive with body) - currently unsupported
attachURLs | List of URLs to be attached to the mail.

void invokeBrowser ( const QString &url ) | ### invokeBrowser

[slot]

Invokes the standard browser. Note that you should only do this when you know for sure that the browser can handle the URL (i.e. its mimetype). In doubt, if the URL can point to an image or anything else than directory or HTML, prefer to use new KRun( url ).

Parameters:

url | The destination address

QCString launcher () | ### launcher

[static]

Returns the DCOP name of the service launcher. This will be something like klaucher_$host_$uid.

Returns: the name of the service launcher

int startServiceByName ( const QString& _name, const QString &URL, QString *error=0, QCString *dcopService=0, int *pid=0, const QCString &startup_id = "", bool noWait = false ) | ### startServiceByName

[static]

Starts a service based on the (translated) name of the service. E.g. "Web Browser"

Parameters:

name | the name of the service
URL | if not empty this URL is passed to the service
error | On failure, `error` contains a description of the error that occurred. If the pointer is 0, the argument will be ignored
dcopService | On success, `dcopService` contains the DCOP name under which this service is available. If empty, the service does not provide DCOP services. If the pointer is 0 the argument will be ignored
pid | On success, the process id of the new service will be written here. If the pointer is 0, the argument will be ignored.
startup_id | for app startup notification, "0" for none, "" ( empty string ) is the default
noWait | if set, the function does not wait till the service is running.

Returns: an error code indicating success (== 0) or failure (> 0).

int startServiceByName ( const QString& _name, const QStringList &URLs=QStringList(), QString *error=0, QCString *dcopService=0, int *pid=0, const QCString &startup_id = "", bool noWait = false ) | ### startServiceByName

[static]

Starts a service based on the (translated) name of the service. E.g. "Web Browser"

Parameters:

name | the name of the service
URLs | if not empty these URLs will be passed to the service
error | On failure, `error` contains a description of the error that occurred. If the pointer is 0, the argument will be ignored
dcopService | On success, `dcopService` contains the DCOP name under which this service is available. If empty, the service does not provide DCOP services. If the pointer is 0 the argument will be ignored
pid | On success, the process id of the new service will be written here. If the pointer is 0, the argument will be ignored.
startup_id | for app startup notification, "0" for none, "" ( empty string ) is the default
noWait | if set, the function does not wait till the service is running.

Returns: an error code indicating success (== 0) or failure (> 0).

int startServiceByDesktopPath ( const QString& _name, const QString &URL, QString *error=0, QCString *dcopService=0, int *pid = 0, const QCString &startup_id = "", bool noWait = false ) | ### startServiceByDesktopPath

[static]

Starts a service based on the desktop path of the service. E.g. "Applications/konqueror.desktop" or "/home/user/bla/myfile.desktop"

Parameters:

name | the path of the desktop file
URL | if not empty this URL is passed to the service
error | On failure, `error` contains a description of the error that occurred. If the pointer is 0, the argument will be ignored
dcopService | On success, `dcopService` contains the DCOP name under which this service is available. If empty, the service does not provide DCOP services. If the pointer is 0 the argument will be ignored
pid | On success, the process id of the new service will be written here. If the pointer is 0, the argument will be ignored.
startup_id | for app startup notification, "0" for none, "" ( empty string ) is the default
noWait | if set, the function does not wait till the service is running.

Returns: an error code indicating success (== 0) or failure (> 0).

int startServiceByDesktopPath ( const QString& _name, const QStringList &URLs=QStringList(), QString *error=0, QCString *dcopService=0, int *pid = 0, const QCString &startup_id = "", bool noWait = false ) | ### startServiceByDesktopPath

[static]

Starts a service based on the desktop path of the service. E.g. "Applications/konqueror.desktop" or "/home/user/bla/myfile.desktop"

Parameters:

name | the path of the desktop file
URLs | if not empty these URLs will be passed to the service
error | On failure, `error` contains a description of the error that occurred. If the pointer is 0, the argument will be ignored
dcopService | On success, `dcopService` contains the DCOP name under which this service is available. If empty, the service does not provide DCOP services. If the pointer is 0 the argument will be ignored
pid | On success, the process id of the new service will be written here. If the pointer is 0, the argument will be ignored.
startup_id | for app startup notification, "0" for none, "" ( empty string ) is the default
noWait | if set, the function does not wait till the service is running.

Returns: an error code indicating success (== 0) or failure (> 0).

int startServiceByDesktopName ( const QString& _name, const QString &URL, QString *error=0, QCString *dcopService=0, int *pid = 0, const QCString &startup_id = "", bool noWait = false ) | ### startServiceByDesktopName

[static]

Starts a service based on the desktop name of the service. E.g. "konqueror"

Parameters:

name | the desktop name of the service
URL | if not empty this URL is passed to the service
error | On failure, `error` contains a description of the error that occurred. If the pointer is 0, the argument will be ignored
dcopService | On success, `dcopService` contains the DCOP name under which this service is available. If empty, the service does not provide DCOP services. If the pointer is 0 the argument will be ignored
pid | On success, the process id of the new service will be written here. If the pointer is 0, the argument will be ignored.
startup_id | for app startup notification, "0" for none, "" ( empty string ) is the default
noWait | if set, the function does not wait till the service is running.

Returns: an error code indicating success (== 0) or failure (> 0).

int startServiceByDesktopName ( const QString& _name, const QStringList &URLs=QStringList(), QString *error=0, QCString *dcopService=0, int *pid = 0, const QCString &startup_id = "", bool noWait = false ) | ### startServiceByDesktopName

[static]

Starts a service based on the desktop name of the service. E.g. "konqueror"

Parameters:

name | the desktop name of the service
URLs | if not empty these URLs will be passed to the service
error | On failure, `error` contains a description of the error that occurred. If the pointer is 0, the argument will be ignored
dcopService | On success, `dcopService` contains the DCOP name under which this service is available. If empty, the service does not provide DCOP services. If the pointer is 0 the argument will be ignored
pid | On success, the process id of the new service will be written here. If the pointer is 0, the argument will be ignored.
startup_id | for app startup notification, "0" for none, "" ( empty string ) is the default
noWait | if set, the function does not wait till the service is running.

Returns: an error code indicating success (== 0) or failure (> 0).

int kdeinitExec ( const QString& name, const QStringList &args=QStringList(), QString *error=0, int *pid = 0 ) | ### kdeinitExec

[static]

Starts a program via kdeinit. There will be no application startup notification, so you should use it only for starting internal processes.

program name and arguments are converted to according to the local encoding and passed as is to kdeinit.

Parameters:

name | Name of the program to start
args | Arguments to pass to the program
error | On failure, `error` contains a description of the error that occurred. If the pointer is 0, the argument will be ignored
pid | On success, the process id of the new service will be written here. If the pointer is 0, the argument will be ignored.

Returns: an error code indicating success (== 0) or failure (> 0).

int kdeinitExecWait ( const QString& name, const QStringList &args=QStringList(), QString *error=0, int *pid = 0 ) | ### kdeinitExecWait

[static]

Starts a program via kdeinit and wait for it to finish.

Like kdeinitExec(), but it waits till the program is finished. As such it behaves similar to the system(...) function.

Parameters:

name | Name of the program to start
args | Arguments to pass to the program
error | On failure, `error` contains a description of the error that occurred. If the pointer is 0, the argument will be ignored
pid | On success, the process id of the new service will be written here. If the pointer is 0, the argument will be ignored.

Returns: an error code indicating success (== 0) or failure (> 0).

QString caption () | ### caption

[const]

Returns a text for the window caption.

This may be set by "-caption", otherwise it will be equivalent to the name of the executable.

Returns: the text for the window caption

KStyle* kstyle () | ### kstyle

[const]

QString makeStdCaption ( const QString &userCaption, bool withAppName=true, bool modified=false ) | ### makeStdCaption

[const]

Builds a caption that contains the application name along with the userCaption() using a standard layout.

To make a compliant caption for your window, simply do: `setCaption`(kapp->makeStdCaption(yourCaption));

Parameters:

userCaption | The caption string you want to display in the window caption area. Do not include the application name!
withAppName | Indicates that the method shall include or ignore the application name when making the caption string. You are not compliant if you set this to `false`.
modified | If true, a 'modified' sign will be included in the returned string. This is useful when indicating that a file is modified, i.e., it contains data that has not been saved.

Returns: the created caption

QString tempSaveName ( const QString& pFilename ) | ### tempSaveName

[const]

Get a file name in order to make a temporary copy of your document.

Parameters:

pFilename | The full path to the current file of your document.

Returns: A new filename for auto-saving.

QString checkRecoverFile ( const QString& pFilename, bool& bRecover ) | ### checkRecoverFile

[const]

Check whether an auto-save file exists for the document you want to open.

Parameters:

pFilename | The full path to the document you want to open.
bRecover | This gets set to true if there was a recover file.

Returns: The full path of the file to open.

Display * getDisplay () | ### getDisplay

Get the X11 display

Returns: the X11 Display

void enableStyles () | ### enableStyles

Enables style plugins.

This is useful only to applications that normally do not display a GUI and create the KApplication with allowStyles set to false.

void disableStyles () | ### disableStyles

Disables style plugins.

Current style plugins do not get unloaded.

This is only useful when used in combination with enableStyles().

void installX11EventFilter ( QWidget* filter ) | ### installX11EventFilter

Installs widget filter as global X11 event filter.

The widget filter receives XEvents in its standard QWidget::x11Event() function.

Warning: Only do this when absolutely necessary. An installed X11 filter can slow things down.

int random () | ### random

[static]

Generates a uniform random number.

Returns: A truly unpredictable number in the range [0, RAND_MAX)

QString randomString (int length) | ### randomString

[static]

Generates a random string. It operates in the range [A-Za-z0-9]

Parameters:

length | Generate a string of this length.

Returns: the random string

void addKipcEventMask (int id) | ### addKipcEventMask

Adds a message type to the KIPC event mask. You can only add "system messages" to the event mask. These are the messages with id < 32. Messages with id >= 32 are user messages.

Parameters:

id | The message id. See KIPC::Message.

See also: KIPC, removeKipcEventMask(), kipcMessage()

void removeKipcEventMask (int id) | ### removeKipcEventMask

Removes a message type from the KIPC event mask. This message will not be handled anymore.

Parameters:

id | The message id.

See also: KIPC, addKipcEventMask(), kipcMessage()

QCString startupId () | ### startupId

[const]

Returns the app startup notification identifier for this running application.

Returns: the startup notification identifier

void setStartupId ( const QCString& startup_id ) | ### setStartupId

Sets a new value for the application startup notification window property for newly created toplevel windows.

Parameters:

the | startup notification identifier

QString geometryArgument () | ### geometryArgument

[const]

Returns the argument to --geometry if any, so the geometry can be set wherever necessary

Returns: the geometry argument, or QString::null if there is none

void installKDEPropertyMap () | ### installKDEPropertyMap

Install a Qt SQL property map with entries for all KDE widgets Call this in any application using KDE widgets in QSqlForm or QDataView.

bool authorize (const QString &genericAction) | ### authorize

Returns whether a certain action is authorized

Parameters:

genericAction | The name of a generic action

Returns: true if the action is authorized

bool authorizeKAction (const char *action) | ### authorizeKAction

Returns whether a certain KAction is authorized.

Parameters:

action | The name of a KAction action. The name is prepended with "action/" before being passed to authorize()

Returns: true if the KAction is authorized

bool authorizeURLAction (const QString &action, const KURL &baseURL, const KURL &destURL) | ### authorizeURLAction

Returns whether a certain URL related action is authorized.

Parameters:

action | The name of the action. Known actions are list (may be listed (e.g. in file selection dialog)), link (may be linked to), open (may open) and redirect (may be redirected to)
baseURL | The url where the action originates from
destURL | The object of the action

Returns: true when the action is authorized, false otherwise.

enum { ShiftModifier = 1<<0, LockModifier = 1<<1, ControlModifier = 1<<2, Modifier1 = 1<<3, Modifier2 = 1<<4, Modifier3 = 1<<5, Modifier4 = 1<<6, Modifier5 = 1<<7 } | ###

uint keyboardModifiers () | ### keyboardModifiers

[static]

Returns the currently pressed keyboard modifiers (e.g. shift, control, etc.) Usually you simply want to test for those in key events, in which case QKeyEvent::state() does the job (or QKeyEvent::key() to notice when a modifier is pressed alone). But it can be useful to query for the status of the modifiers at another moment (e.g. some KDE apps do that upon a drop event).

Returns: the keyboard modifiers

enum { Button1Pressed = 1<<8, Button2Pressed = 1<<9, Button3Pressed = 1<<10, Button4Pressed = 1<<11, Button5Pressed = 1<<12 } | ###

uint mouseState () | ### mouseState

[static]

Returns the currently pressed mouse buttons. Usually you simply want to test for those in mouse events, in which case QMouseEvent::button() does the job (or QMouseEvent::state()). But it can be useful to query for the status of the mouse buttons at another moment. To query for the mouse pointer position, use QCursor::pos().

Returns: the currently pressed mouse buttons

void ref () | ### ref

[slot]

Tells KApplication about one more operation that should be finished before the application exits. The standard behavior is to exit on the "last window closed" event, but some events should outlive the last window closed (e.g. a file copy for a file manager, or 'compacting folders on exit' for a mail client).

void deref () | ### deref

[slot]

Tells KApplication that one operation such as those described in just finished. The application exits if the counter is back to 0.

KApplication ( bool allowStyles, bool GUIenabled, KInstance* _instance ) | ### KApplication

[protected]

bool x11EventFilter ( XEvent * ) | ### x11EventFilter

[protected]

Used to catch X11 events

Reimplemented from QApplication.

Display * display | ### display

[protected]

Atom kipcCommAtom | ### kipcCommAtom

[protected]

int kipcEventMask | ### kipcEventMask

[protected]

static KApplication * KApp | ### KApp

[protected]

int pArgc | ### pArgc

[protected]

bool notify (QObject *receiver, QEvent *event) | ### notify

Reimplemented from QApplication.

int xioErrhandler () | ### xioErrhandler

void iceIOErrorHandler ( _IceConn *conn ) | ### iceIOErrorHandler

static bool loadedByKdeinit | ### loadedByKdeinit

void startKdeinit () | ### startKdeinit

[static]

enum SettingsCategory { SETTINGS_MOUSE, SETTINGS_COMPLETION, SETTINGS_PATHS, SETTINGS_POPUPMENU, SETTINGS_QT, SETTINGS_SHORTCUTS } | ### SettingsCategory

Valid values for the settingsChanged signal

QPalette createApplicationPalette () | ### createApplicationPalette

[static]

Used to obtain the QPalette that will be used to set the application palette.

This is only useful for configuration modules such as krdb and should not be used in normal circumstances.

Returns: the QPalette

QPalette createApplicationPalette ( KConfig *config, int contrast ) | ### createApplicationPalette

[static]

Raw access for use by KDM.

void kdisplayPaletteChanged () | ### kdisplayPaletteChanged

[signal]

Emitted when KApplication has changed its palette due to a KControl request.

Normally, widgets will update their palette automatically, but you should connect to this to program special behavior.

void kdisplayStyleChanged () | ### kdisplayStyleChanged

[signal]

Emitted when KApplication has changed its GUI style in response to a KControl request.

Normally, widgets will update their styles automatically (as they would respond to an explicit setGUIStyle() call), but you should connect to this to program special behavior.

void kdisplayFontChanged () | ### kdisplayFontChanged

[signal]

Emitted when KApplication has changed its font in response to a KControl request.

Normally widgets will update their fonts automatically, but you should connect to this to monitor global font changes, especially if you are using explicit fonts.

void appearanceChanged () | ### appearanceChanged

[signal]

Emitted when KApplication has changed either its GUI style, its font or its palette in response to a kdisplay request. Normally, widgets will update their styles automatically, but you should connect to this to program special behavior.

void toolbarAppearanceChanged (int) | ### toolbarAppearanceChanged

[signal]

Emitted when the settings for toolbars have been changed. KToolBar will know what to do.

void backgroundChanged (int desk) | ### backgroundChanged

[signal]

Emitted when the desktop background has been changed by `kcmdisplay`.

Parameters:

desk | The desktop whose background has changed.

void settingsChanged (int category) | ### settingsChanged

[signal]

Emitted when the global settings have been changed - see KGlobalSettings KApplication takes care of calling reparseConfiguration on KGlobal::config() so that applications/classes using this only have to re-read the configuration

Parameters:

category | the category among the enum above

void iconChanged (int group) | ### iconChanged

[signal]

Emitted when the global icon settings have been changed.

Parameters:

group | the new group

void kipcMessage (int id, int data) | ### kipcMessage

[signal]

Emitted when a KIPC user message has been received.

Parameters:

id | the message id
data | the data

See also: KIPC, Message, addKipcEventMask, removeKipcEventMask

void saveYourself () | ### saveYourself

[signal]

Session management asks you to save the state of your application.

This signal is provided for compatibility only. For new applications, simply use KMainWindow. By reimplementing KMainWindow::queryClose(), KMainWindow::saveProperties() and KMainWindow::readProperties() you can simply handle session management for applications with multiple toplevel windows.

For purposes without KMainWindow, create an instance of KSessionManaged and reimplement the functions KSessionManaged::commitData() and/or KSessionManaged::saveState()

If you still want to use this signal, here is what you should do:

Connect to this signal in order to save your data. Do NOT manipulate the UI in that slot, it is blocked by the session manager.

Use the sessionConfig() KConfig object to store all your instance specific data.

Do not do any closing at this point! The user may still select Cancel wanting to continue working with your application. Cleanups could be done after shutDown() (see the following).

void shutDown () | ### shutDown

[signal]

Your application is killed. Either by your program itself, `xkill` or (the usual case) by KDE's logout.

The signal is particularly useful if your application has to do some last-second cleanups. Note that no user interaction is possible at this state.

void virtual_hook ( int id, void* data ) | ### virtual_hook

[protected virtual]

Reimplemented from KInstance.

- Version: $Id: kapplication.h,v 1.278.2.1 2003/03/03 14:39:42 lunakl Exp $
- Author: Matthias Kalle Dalheimer
- Generated: root on macppc.ports.openbsd.org on Sat Sep 6 10:36:15 2003, using kdoc 2.0a54.